//by SB 2:469/141

#ifndef __PORTLIB_C_
#define __PORTLIB_C_
#include <ctype.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <dirent.h>
#include <fnmatch.h>
#include <fcntl.h>
#include "_dos.h"
#include <time.h>


#define DIR_MODE 0666

#ifndef __EMX__
char *strupr( char *__string )
{
int i,len;
len=strlen(__string);
 for(i=0;i<len;i++) __string[i]=toupper(__string[i]);
 return __string;
}

char *strlwr( char *__string )
{
int i,len;
len=strlen(__string);
 for(i=0;i<len;i++) __string[i]=tolower(__string[i]);
 return __string;
}
#endif

long filelength(int __handle)
{
 off_t cur_pos=lseek(__handle,0,SEEK_CUR);
 off_t len=lseek(__handle,0,SEEK_END);
 lseek(__handle,cur_pos,SEEK_SET);
 return (long)len;
}

int spawnvp(int __mode,const char *__path,char *const *__argv)
{
int pid, status;
#ifdef __DEBUG__
 printf("spawnvp: %s\n",__path);
#endif
   pid = fork();
   if (pid == -1) return -1;
   if (pid == 0) {
    execvp(__path,__argv);
   }
   do {
       if (waitpid(pid, &status, 0) == -1) {
           if (errno != EINTR) return -10;
	   else return -11;
       } else if(WIFEXITED(status)) {
         return WEXITSTATUS(status);
	}
              else return -1;
   } while(1);
}

void _time2dos(time_t __dos_time, unsigned short *__date, unsigned short *__time)
{
 struct tm *ftime;
 unsigned short tmp=0,tmp1,tmp2,tmp3;

 ftime=localtime(&__dos_time);

 tmp1=(unsigned short)ftime->tm_mday;
 tmp2=(unsigned short)ftime->tm_mon;
 tmp3=(unsigned short)ftime->tm_year;

 tmp=tmp+(tmp2<<4)+(tmp3<<8);
 *__date=tmp;

 tmp1=(unsigned short)ftime->tm_sec/2;
 tmp2=(unsigned short)ftime->tm_min;
 tmp3=(unsigned short)ftime->tm_hour;

 tmp=tmp+(tmp2<<4)+(tmp3<<8);
 *__time=tmp;
}

unsigned _dos_findfirst(const char *__path,unsigned __attr,struct find_t *__buf )
{
int len=strlen(__path);
int __handle;
char __full_path[256];
struct dirent *__entry;
struct stat __stat;
unsigned ret=0;
__buf->__entry=NULL;
__buf->__pattern=NULL;
__buf->__path_only=NULL;

 while((__path[len-1]!='/')&&(len>0)) len--;
 if((len>0)&&(__path[len-1]=='/')) {
  __buf->__path_only=(char *)calloc(len,1);
  strncpy(__buf->__path_only,__path,len-1);
 } else return 1;
 __buf->__entry=opendir(__buf->__path_only);
 if(__buf->__entry==NULL) {
  perror("opendir/_dos_findfirst error");
#ifdef __DEBUG__
  printf("open(_src path): %s\n",__path);
  printf("open: %s\n",__buf->__path_only);
#endif
  return 2;
 }
 __entry=readdir(__buf->__entry);
 if(__entry==NULL) {
  return 3;
 }
 __buf->__pattern=(char *)calloc(strlen(__path)-strlen(__buf->__path_only),1);
 strncpy(__buf->__pattern,__path+(strlen(__buf->__path_only)+1),strlen(__path)-strlen(__buf->__path_only));
 memset(__full_path,0,256);
 while(__entry!=NULL){
  ret=fnmatch(__buf->__pattern,__entry->d_name,0);
  if(!ret) {
   strcpy(__buf->name,__entry->d_name);
   /*fill struct stat __stat*/
   strcpy(__full_path,__buf->__path_only);
   strcat(__full_path,"/");
   strcat(__full_path,__entry->d_name);
   __handle=open(__full_path,O_RDONLY);
   if(__handle==-1) {
    perror("open/_dos_findfirst error");
#ifdef __DEBUG__
  printf("open(src path): %s\n",__buf->__path_only);
  printf("open: %s\n",__full_path);
#endif
    ret=3;
    break;
   }
   if(fstat(__handle,&__stat)==-1) perror("fstat error/_dos_findfirst");
   __buf->size=__stat.st_size;
   __buf->attrib=0;
   _time2dos(__stat.st_mtime,&__buf->wr_date,&__buf->wr_time);
   if(__stat.st_mode&S_IFDIR) __buf->attrib&=0x10;
   if(__stat.st_mode&S_IFDIR) {__entry=readdir(__buf->__entry);continue;}
   if(close(__handle)==-1) perror("close/_dos_findfirst error");
   #ifdef __DEBUG__
    printf("Path: %s\n",__buf->__path_only);
    printf("FullPath: %s\n",__full_path);
    printf("Pattern: %s\n",__buf->__pattern);
    printf("Found name: %s\n",__buf->name);
    printf("Filesize: %u\n",__buf->size);
   #endif
   memset(__full_path,0,256);
   __buf->dir_pos=telldir(__buf->__entry);
   break;
  }
  if(ret) {
   __entry=readdir(__buf->__entry);
   if(__entry==NULL) {ret=3;break;}
  }
 }
#ifdef __DEBUG__
 printf("Ret: %d\n",ret);
#endif
 return ret;
}

unsigned _dos_findnext( struct find_t *__buf ) {
struct dirent *__entry;
struct stat __stat;
unsigned ret=0;
char __full_path[256];
int __handle;

 memset(__full_path,0,256);
 seekdir(__buf->__entry,__buf->dir_pos);
 __entry=readdir(__buf->__entry);
 if(__entry==NULL) ret=3;
 while(__entry!=NULL){
  ret=fnmatch(__buf->__pattern,__entry->d_name,0);
  if(!ret) {
   strcpy(__buf->name,__entry->d_name);
   /*fill struct stat __stat*/
   strcpy(__full_path,__buf->__path_only);
   strcat(__full_path,"/");
   strcat(__full_path,__entry->d_name);
   __handle=open(__full_path,O_RDONLY);
   if(__handle==-1) {
    perror("open/_dos_findnext error");
#ifdef __DEBUG__
  printf("open(src path): %s\n",__buf->__path_only);
  printf("open: %s\n",__full_path);
#endif
    ret=3;
    break;
   }
   if(fstat(__handle,&__stat)==-1) perror("fstat error/_dos_findnext");
   __buf->size=__stat.st_size;
   __buf->attrib=0;
   _time2dos(__stat.st_mtime,&__buf->wr_date,&__buf->wr_time);
   if(__stat.st_mode&S_IFDIR) __buf->attrib&=0x10;
   if(__stat.st_mode&S_IFDIR) {__entry=readdir(__buf->__entry);continue;}
   if(close(__handle)==-1) perror("close/_dos_findnext error");
   memset(__full_path,0,256);
   __buf->dir_pos=telldir(__buf->__entry);
   break;
  }
  if(ret) {
   __entry=readdir(__buf->__entry);
   if(__entry==NULL) {ret=3;break;}
  }
 }
 return ret;
}

unsigned _dos_findclose( struct find_t *__buf )
{
 if(__buf->__path_only!=NULL) free(__buf->__path_only);
 if(__buf->__pattern!=NULL) free(__buf->__pattern);
 if(__buf->__entry!=NULL) if(closedir(__buf->__entry)) perror("closedir/_dos_findclose error");
 return errno;
}

char *itoa( int __value, char *__buf, int __radix )
{
 switch (__radix) {
  case 2: sprintf(__buf,"%o%c",__value,0);break;
  case 10: sprintf(__buf,"%u%c",__value,0);break;
  case 16: sprintf(__buf,"%x%c",__value,0);break;
  default:printf("itoa: Unknown __radix: %d",__radix);
 }
#ifdef __DEBUG__
 printf("(%s,%d) itoa: %s\n",__FILE__,__LINE__,__buf);
#endif
return __buf;
}
void _dos_getdrive( unsigned *__drive )
{
}
void _dos_setdrive( unsigned __drivenum, unsigned *__drives )
{
}
int mkdir( const char *__path )
{
// return __mkdir(__path,DIR_MODE);
 return mkdir(__path,DIR_MODE);
}

int  chsize(int __handle,long __size)
{
 return ftruncate(__handle,__size);
}

unsigned _dos_getftime( int __handle, unsigned short *__date, unsigned short *__time )
{
 struct stat __stat;
 if(fstat(__handle,&__stat)==-1) {perror("fstat/_dos_getftime error");return 1;}
 else _time2dos(__stat.st_mtime,__date,__time);
 return 0;
}

#endif
