#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "tools.h"
#include "diskmap.h"


TDiskMap::TDiskMap()
{ memset(map, '\0', (int)sizeof(char*) * MAXDRIVES );
};

void TDiskMap::Remove()
{ for (int i=0; i<MAXDRIVES;i++)  if (map[i]) free (map[i]);
};

void TDiskMap::Set(char disk, char* path)
{
   path = trim(path);
   int len = strlen(path);
   if ( disk > 'Z') disk-=('a'-'A');
   if ( path[len]=='/') path[len]='\0';
   map[disk-'A']=strdup(path);
}
void TDiskMap::Get(char disk, char* path)
{
   if (disk>'Z') disk-='a'-'A';
   if (map[disk-'A']!=NULL) strcpy(path, map[disk-'A']);
   else *path='\x0';
}
char* TDiskMap::GetPath(char* dest, char* src )
{
   char* p=strchr(src, ':');
   if ( p )
   {
      *dest='\0';
      Get(p[-1], dest);
      strcat(dest, p+1);

      p = dest;
      for(;;)                         //reset slash to normal (from dos to unix)
      {
          if (p[0]=='\x0') break;
          if (p[0]=='\\' ) p[0]='/';
          if (p[0] >= 'A' && p[0] <= 'Z') p[0]+='a'-'A';
          p++;
      }
      return dest;
   }
   else
   {  strcpy(dest, src);
   }

   return dest;
}

void set_dmap(TDiskMap* p, char *value)
{
    char disk;
    char path[256];
    sscanf(value, "%c %s", &disk, path);
    p->Set(disk, path);
};