#ifndef __MAPPATH_CC_
#define __MAPPATH_CC_
#include "mappath.h"
#include <string.h>
#include <stdio.h>

mappath *pmapper;

mappath::mappath()
{
 path=(struct mpath **)malloc(sizeof(struct mpath *));
 if(path==NULL) perror("malloc");
 count=0;
}

mappath::~mappath()
{
int i;
 if(count) for(i=0;i<count;i++) free(path[i]);
 free(path);
}

int mappath::addpath(char *_src, char *_dest, char _softremap)
{
 path=(struct mpath **)realloc(path,sizeof(struct mpath *)*(count+1));
 if(path==NULL) {perror("malloc");return count;}
 path[count]=(struct mpath *)malloc(sizeof(struct mpath));
 if(path[count]==NULL) {count--;perror("malloc");return count;}
 strncpy(path[count]->dospath,_src,MAXPATHLEN);
 strncpy(path[count]->lnxpath,_dest,MAXPATHLEN);
 path[count]->softremap=_softremap;
 count++;
 return count-1;
}

char *mappath::remap(char *_path)
{
int i,j;
size_t len;
char area_file[MAXPATHLEN];
memset(area_file,0,256);
 for(i=0;i<count;i++) {
  if(path[i]->softremap) {
   if(!strncasecmp(_path,path[i]->dospath,strlen(path[i]->dospath))) {
    strcpy(area_file,_path+strlen(path[i]->dospath));
    memset(_path,0,strlen(_path));
    strcpy(_path,path[i]->lnxpath);
    strcat(_path,area_file);
    if(strchr(_path,'\\'))
     for(j=0;j<strlen(_path);j++) if(_path[j]=='\\') _path[j]='/';
    printf("SoftRemap: %s\n",_path);
    return _path;
   }
  } else {
   if(strrchr(_path,'\\')) strcpy(area_file,strrchr(_path,'\\')+1);
   len=strlen(_path)-strlen(area_file);
   if((!strncasecmp(_path,path[i]->dospath,len))&&(strlen(path[i]->dospath)==len)) {
    strncpy(_path,path[i]->lnxpath,MAXPATHLEN);
    strcat(_path,area_file);
    if(strchr(_path,'\\'))
     for(j=0;j<strlen(_path);j++) if(_path[j]=='\\') _path[j]='/';
    printf("Remap: %s\n",_path);
    return _path;
   }
  }
 }
 return _path;
}
#endif